//------------------------------------------------------------------------------
// <auto-generated>
//      Generated by NativeAssist version 1.0.0.0 with Split Generator.
//      Do not modify this file unless necessary.
// </auto-generated>
//------------------------------------------------------------------------------

namespace NativeFx.Interop;

using System;
using GTA.Native;
using GTA;
using GTA.Math;

public static partial class Natives 
{
public static class Water {
/// <summary>
/// This function set height to the value of z-axis of the water surface.<br /><br />This function works with sea and lake. However it does not work with shallow rivers (e.g. raton canyon will return -100000.0f)<br /><br />note: seems to return true when you are in water
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Water<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xF6829842C06AE524<br />
/// </para>
/// </remarks>
public static bool GetWaterHeight(float x, float y, float z, ref float height){
var nativeAssistPointerVar0 = height;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0xF6829842C06AE524uL, x, y, z, &nativeAssistPointerVar0);
}
height = nativeAssistPointerVar0;
return retVal;
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Water<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x8EE6B53CE13A9794<br />
/// </para>
/// </remarks>
public static bool GetWaterHeightNoWaves(float x, float y, float z, ref float height){
var nativeAssistPointerVar0 = height;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0x8EE6B53CE13A9794uL, x, y, z, &nativeAssistPointerVar0);
}
height = nativeAssistPointerVar0;
return retVal;
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Water<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xFFA5D878809819DB<br />
/// </para>
/// </remarks>
public static bool TestProbeAgainstWater(float x1, float y1, float z1, float x2, float y2, float z2, ref Vector3 result){
var nativeAssistPointerVar0 = result;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0xFFA5D878809819DBuL, x1, y1, z1, x2, y2, z2, &nativeAssistPointerVar0);
}
result = nativeAssistPointerVar0;
return retVal;
}

/// <summary>
/// enum eScriptWaterTestResult<br />{<br />	SCRIPT_WATER_TEST_RESULT_NONE,<br />	SCRIPT_WATER_TEST_RESULT_WATER,<br />	SCRIPT_WATER_TEST_RESULT_BLOCKED,<br />};
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Water<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x8974647ED222EA5F<br />
/// </para>
/// </remarks>
public static int TestProbeAgainstAllWater(float x1, float y1, float z1, float x2, float y2, float z2, int flags, ref float waterHeight){
var nativeAssistPointerVar0 = waterHeight;
int retVal;
unsafe {
retVal = Function.Call<int>((Hash)0x8974647ED222EA5FuL, x1, y1, z1, x2, y2, z2, flags, &nativeAssistPointerVar0);
}
waterHeight = nativeAssistPointerVar0;
return retVal;
}

/// <summary>
/// See TEST_PROBE_AGAINST_ALL_WATER.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Water<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x2B3451FA1E3142E2<br />
/// </para>
/// </remarks>
public static int TestVerticalProbeAgainstAllWater(float x, float y, float z, int flags, ref float waterHeight){
var nativeAssistPointerVar0 = waterHeight;
int retVal;
unsafe {
retVal = Function.Call<int>((Hash)0x2B3451FA1E3142E2uL, x, y, z, flags, &nativeAssistPointerVar0);
}
waterHeight = nativeAssistPointerVar0;
return retVal;
}

/// <summary>
/// Sets the water height for a given position and radius.<br />
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Water<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xC443FD757C3BA637<br />
/// </para>
/// </remarks>
public static void ModifyWater(float x, float y, float radius, float height){
Function.Call((Hash)0xC443FD757C3BA637uL, x, y, radius, height);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Water<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xFDBF4CDBC07E1706<br />
/// </para>
/// </remarks>
public static int AddExtraCalmingQuad(float xLow, float yLow, float xHigh, float yHigh, float height){
return Function.Call<int>((Hash)0xFDBF4CDBC07E1706uL, xLow, yLow, xHigh, yHigh, height);
}

/// <summary>
/// p0 is the handle returned from ADD_EXTRA_CALMING_QUAD
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Water<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xB1252E3E59A82AAF<br />
/// </para>
/// </remarks>
public static void RemoveExtraCalmingQuad(int calmingQuad){
Function.Call((Hash)0xB1252E3E59A82AAFuL, calmingQuad);
}

/// <summary>
/// Sets a value that determines how aggressive the ocean waves will be. Values of 2.0 or more make for very aggressive waves like you see during a thunderstorm.<br /><br />Works only ~200 meters around the player.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Water<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xB96B00E976BE977F<br />
/// </para>
/// </remarks>
public static void SetDeepOceanScaler(float intensity){
Function.Call((Hash)0xB96B00E976BE977FuL, intensity);
}

/// <summary>
/// Gets the aggressiveness factor of the ocean waves.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Water<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x2B2A2CC86778B619<br />
/// </para>
/// </remarks>
public static float GetDeepOceanScaler(){
return Function.Call<float>((Hash)0x2B2A2CC86778B619uL);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Water<br />
/// <b>From Build:</b> 573<br />
/// <b>Native ID:</b> 0x547237AA71AB44DE<br />
/// </para>
/// </remarks>
public static void SetCalmedWaveHeightScaler(float height){
Function.Call((Hash)0x547237AA71AB44DEuL, height);
}

/// <summary>
/// Sets the waves intensity back to original (1.0 in most cases).
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Water<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x5E5E99285AE812DB<br />
/// </para>
/// </remarks>
public static void ResetDeepOceanScaler(){
Function.Call((Hash)0x5E5E99285AE812DBuL);
}

}}
